--
-- Leboulch
-- @poc@lypse
-- Copyright (C) Ls-Modteam-France, All Rights Reserved. 

Leboulch = {};

function Leboulch.prerequisitesPresent(specializations)
    return true;
end;

function Leboulch:load(xmlFile)
 self.toggleSupport = SpecializationUtil.callSpecializationsFunction("toggleSupport");  
    self.manualSupportAnimation = getXMLString(xmlFile, "vehicle.manualSupport#animationName");
    self.supportRangeIndex = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.manualSupport#rangeIndex"));
    self.isInRangeSupport = false;   
    self.isSupportDown = true;
     
   self.smokeParticleSystems = {};
    local entry = {};
      entry.ps = {};
      Utils.loadParticleSystem(xmlFile, entry.ps, "vehicle.smokeParticleSystem", self.components, false, nil, self.baseDirectory);
      if table.getn(entry.ps) > 0 then
          entry.isActive = false;
          table.insert(self.smokeParticleSystems, entry);
      end
      local i=0;
      while true do
          local baseName = string.format("vehicle.smokeParticleSystems.smokeParticleSystem(%d)", i);
          if not hasXMLProperty(xmlFile, baseName) then
              break;
          end;
          local entry = {};
          entry.ps = {};
          Utils.loadParticleSystem(xmlFile, entry.ps, baseName, self.components, false, nil, self.baseDirectory);
          if table.getn(entry.ps) > 0 then
              entry.isActive = false;
             entry.cuttingArea = i+1;
              table.insert(self.smokeParticleSystems, entry);
          end
          i = i+1;
      end; 
   self.porte = false;   
 
end;


function Leboulch:delete()
for _, entry in ipairs(self.smokeParticleSystems) do
          Utils.deleteParticleSystem(entry.ps);
          entry.isActive = false;
end; 
end;

function Leboulch:readStream(streamId, connection) 
 local isSupportDown = streamReadBool(streamId);
	self:toggleSupport(isSupportDown, true);
        self.porte = streamReadBool(streamId);  
end;

function Leboulch:writeStream(streamId, connection) 
        streamWriteBool(streamId, self.isSupportDown);
        streamWriteBool(streamId, self.porte);
end;

function Leboulch:mouseEvent(posX, posY, isDown, isUp, button)   
end;

function Leboulch:keyEvent(unicode, sym, modifier, isDown)     
end;


function Leboulch:update(dt)
  if self:getIsActive() then		
		if self.isClient and self:getIsActiveForInput(false) and not self:hasInputConflictWithSelection() then
			-- Show warning about the support being down
			if self.isSupportDown then
				g_currentMission:addWarning(string.format(g_i18n:getText("BJR_SUPPORT_WARNING")), 0.018, 0.033);
			end;
		end;
	end;
         if self.supportRangeIndex then
		-- Manage key events for inrange support --
		if self.isInRangeSupport then
			if InputBinding.hasEvent(InputBinding.LOWER_IMPLEMENT) then
				if self.isSupportDown then
					self:toggleSupport(false);
				else
					self:toggleSupport(true);
				end;
			end;
			-- Display key when in range --
			if self.isSupportDown then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BJR_RAISE_SUPPORT")), InputBinding.LOWER_IMPLEMENT);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("BJR_LOWER_SUPPORT")), InputBinding.LOWER_IMPLEMENT);
			end;
		end;
	end;


if self.PTOId or not self.porte then
 self.isTurnedOn = false
end;

if self.sendPorte ~= self.porte then
    self.sendPorte = self.porte;
    PorteEvent:sendEvent(self, self.porte);
end;

if self:getIsActiveForInput() and self:getIsActive() and self.isTurnedOn == false then
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then
			self.porte = not self.porte
		end;
end;
if self:getIsActiveForInput() and self:getIsActive() and self.isTurnedOn == true then
                if InputBinding.isPressed(InputBinding.IMPLEMENT_EXTRA2) then
                         g_currentMission:addWarning(g_i18n:getText("porte_Error"));
                end;
end;
if self:getIsActiveForInput() and self:getIsActive() and self.porte == false then
                if InputBinding.isPressed(InputBinding.IMPLEMENT_EXTRA) then                        
                         g_currentMission:addWarning(g_i18n:getText("porteActive_Error"));
                end;		
end;
end;

function Leboulch:updateTick(dt)


if self.porte then
   self:setAnimationTime(1, self.animationParts[1].animDuration);
else
  self:setAnimationTime(1, self.animationParts[1].startPosition);  
end;


 if self.supportRangeIndex then
		if g_currentMission.player ~= nil then
			-- Getting the distance between the player and the support
			local nearestDistance = 1.5; --max distance allowed
			local px, py, pz = getWorldTranslation(self.supportRangeIndex);
			local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			if distance < nearestDistance then
				self.isInRangeSupport = true;
			else
				self.isInRangeSupport = false;
			end;
		end;
	else
		self.isInRangeSupport = false;
	end;

if self.isClient then
               
               for _,ps in pairs(self.smokeParticleSystems) do                  
                  if (self.currentFillType == Fillable.FILLTYPE_MANURE or self.currentFillType == Fillable.FILLTYPE_COMPOST_SOIL) and self.fillLevel > 3000 and self.movingDirection == 0 then                       
                      Utils.setEmittingState(ps.ps, true);
                  else
                      Utils.setEmittingState(ps.ps, false);
                  end
               end
end;

end;

function Leboulch:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local isSupportDown = Utils.getNoNil(getXMLBool(xmlFile, key .. "#isSupportDown"), false);
	self:toggleSupport(isSupportDown);	
	
    return BaseMission.VEHICLE_LOAD_OK;
end;

function Leboulch:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'isSupportDown="' .. tostring(self.isSupportDown) .. '"';
    return attributes, nil;
end;



function Leboulch:draw() 
   if self.PTOId then
     g_currentMission:addWarning(g_i18n:getText("turnON_Error"));
   end; 
   if not self.porte and self:getIsActive() then 
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("LEBOULCH_LEVER_PORTE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
	else
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("LEBOULCH_BAISSER_PORTE"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA2);
   end; 
end;

function Leboulch:toggleSupport(isSupportDown, noEventSend)
	ToggleSupportEvent.sendEvent(self, isSupportDown, noEventSend);	
	
	if not isSupportDown then
		if self.manualSupportAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualSupportAnimation, -1, nil, true);
		end;
	else
		if self.manualSupportAnimation ~= nil and self.playAnimation ~= nil then
			self:playAnimation(self.manualSupportAnimation, 1, nil, true);
		end;
	end;
	
	self.isSupportDown = isSupportDown;
end;


-- Support event

ToggleSupportEvent = {};
ToggleSupportEvent_mt = Class(ToggleSupportEvent, Event);

InitEventClass(ToggleSupportEvent, "ToggleSupportEvent");

function ToggleSupportEvent:emptyNew()
    local self = Event:new(ToggleSupportEvent_mt);
    return self;
end;

function ToggleSupportEvent:new(object, isSupportDown)
    local self = ToggleSupportEvent:emptyNew()
    self.object = object;
	self.isSupportDown = isSupportDown;
    return self;
end;

function ToggleSupportEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.isSupportDown = streamReadBool(streamId);
    self:run(connection);
end;

function ToggleSupportEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));	
	streamWriteBool(streamId, self.isSupportDown);
end;

function ToggleSupportEvent:run(connection)
	self.object:toggleSupport(self.isSupportDown, true);
end;

function ToggleSupportEvent.sendEvent(object, isSupportDown, noEventSend)
	
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(ToggleSupportEvent:new(object, isSupportDown), nil, nil, object);
		else
			g_client:getServerConnection():sendEvent(ToggleSupportEvent:new(object, isSupportDown));
		end;
	end;
end;

PorteEvent = {};
PorteEvent_mt = Class(PorteEvent, Event);

InitEventClass(PorteEvent, "PorteEvent");

function PorteEvent:emptyNew()
  local self = Event:new(PorteEvent_mt);
  self.className="PorteEvent";
  return self;
end;

function PorteEvent:new(object, porte)
  local self = PorteEvent:emptyNew();
  self.object = object;
  self.porte = porte;
  return self;
end;

function PorteEvent:readStream(streamId, connection)
  self.object = networkGetObject(streamReadInt32(streamId));
  self.porte = streamReadBool(streamId);
  self:run(connection);
end;

function PorteEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, networkGetObjectId(self.object));
  streamWriteBool(streamId, self.porte);
end;

function PorteEvent:run(connection)
  self.object.porte = self.porte;  
  if not connection:getIsServer() then
    g_server:broadcastEvent(PorteEvent:new(self.object, self.porte), nil, connection, self.object);
  end;
end;

function PorteEvent:sendEvent(object, porte, noEventSend)
  if noEventSend == nil or noEventSend == false then
    if g_server ~= nil then
      g_server:broadcastEvent(PorteEvent:new(object, porte), nil, nil, object);
    else
      g_client:getServerConnection():sendEvent(PorteEvent:new(object, porte));
    end;
  end;
end;
